﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=12.8
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.

End Sub

Sub Service_Create

End Sub

Sub Service_Start (StartingIntent As Intent)
	Service.StopAutomaticForeground 'Call this when the background task completes (if there is one)
End Sub

Sub Service_Destroy

End Sub

public Sub getVideoThumb
	Dim jo As JavaObject
	jo.InitializeContext
	jo.RunMethod( "getVideoThumbnails", Array(jo) )
End Sub

#if Java
import android.annotation.SuppressLint;
import android.content.ContentResolver;
import android.content.ContentUris;
import android.content.Context;
import android.content.Intent;
import android.database.Cursor;
import android.database.DatabaseUtils;
import android.graphics.Bitmap;
import android.net.Uri;
import android.os.Build;
import android.os.Environment;
import android.provider.DocumentsContract;
import android.provider.MediaStore;
import android.webkit.MimeTypeMap;
import java.io.File;
import java.text.DecimalFormat;
import java.util.Comparator;
import java.nio.file.Files;
import android.provider.MediaStore.Images.Thumbnails;
import android.provider.MediaStore;
import android.os.CancellationSignal;
import android.util.Size;

    public static void getVideoThumbnails(Context context) {
		//Thumbnails.MICRO_KIND for 96 x 96
		// Thumbnails.MINI_KIND for 512 x 384 px
        Cursor cursor = null;
        ContentResolver resolver = context.getContentResolver();
		
		try {
 	       cursor = resolver.query(MediaStore.Video.Media.EXTERNAL_CONTENT_URI, null, null, null, null);
 		   int idColumn = cursor.getColumnIndex(MediaStore.Video.Media._ID);
      	   int nameColumn = cursor.getColumnIndex(MediaStore.Video.Media.DISPLAY_NAME);
				
		   while (cursor.moveToNext()) {
		       long imageId = cursor.getLong(idColumn);
        	   String imageName = cursor.getString(nameColumn);
					
               Uri imageUri = ContentUris.withAppendedId(MediaStore.Video.Media.EXTERNAL_CONTENT_URI, imageId);
		       BA.Log("Uri: " + imageUri.toString());
               Bitmap bm = MediaStore.Video.Thumbnails.getThumbnail(resolver, imageId, MediaStore.Video.Thumbnails.MICRO_KIND,null);
   			   if (bm == null)
			       BA.Log("could not get thumbnail " + imageId);
			   else
				   BA.Log("thumbnail found. " + bm.getWidth() + "x" + bm.getHeight() + "px");
		   }
        } catch (Exception e) {
	        BA.Log("getThumbnail: " + e.toString());
        } finally {
	          if (cursor != null)
    	          cursor.close();
        }
    }

#End If